/*************************************************************************************************
 * depot.o
 * QDBMδAPI
 *                                                       Copyright(c) 2000-2003 Mikio Hirabayashi
 * 
 *    ͤΥڥϿǡ١ե򰷤Υ롼󽸤Ǥ롣
 *    ǡ¤ˤϥϥåѤϥåʬõڤѤ롣
 *    Ͻϰ¸POSIXXPGUNIXɸˤʤ٤碌褦ˤƤ롣
 *    ƤΥޥҤ DP_ ̾ DP 򡢤ʳγ̾ dp Ƭ˻ġ
 *
 * Ūջ
 *    Ρ֥ȡפȤѸϡmalloc/calloc/realloc ΰݤ뤳Ȥ̣
 *      Ƥ롣ͤȤƥȤ줿ΰΥݥ󥿤֤ؿ¿뤬ΰ
 *      ǤϸƤӽФ¦餦Ȥˤʤ롣
 *    åɥդǤϤʤꥨȥȤǤʤ
 *    intХȤ򲼲ϤǤưʤ
 *************************************************************************************************/


/* Ƚ */
#ifndef _DEPOT_H
#define _DEPOT_H



/*************************************************************************************************
 * API
 *  dpopen ǥǡ١ե򳫤ͤǤDEPOTΥݥ󥿤ϥɥȤƳƼ
 *    Ԥ
 *  ǡ١Ѥ顢ɬ dpclose Ĥ٤Ǥ롣
 *  饤ɤ߽ξѥ⡼ɡˤǥǡ١ե򳫤ݤˤϤΥեФ¾
 *    졢꡼ɤ߹ѥ⡼ɡˤǳݤˤ϶ͭå롣κݤˤϳ
 *    Υåޤǥ֥å롣
 *  ǡ١̿Ūʥ顼ϡʸ夽ΥϥɥФ dpclose Ƥ
 *    ϲ⤻˥顼֤
 *  ѿ dpdbgfd ˤϥǥХåϤեǥץꤹ롣ͤ -1 
 *    ꡢͤʤнϤԤʤ
 *  ѿ dpecode ˤľΥ顼ɤϿ롣ͤ DP_ENOERR Ǥ롣
 *  DEPOT¤ΤΥФľܻȤ뤳ȤϿ侩ʤ
 *************************************************************************************************/


#undef TRUE
#define TRUE           1                 /* ͤο */
#undef FALSE
#define FALSE          0                 /* ͤε */
#undef NULL
#define NULL           ((void *)0)       /* ̵ʥݥ */


typedef enum {                           /* 顼ɤ */
  DP_ENOERR,                             /* 顼ʤ */
  DP_EFATAL,                             /* ̿Ū顼򸡽 */
  DP_EMODE,                              /* ⡼ɤ㤦 */
  DP_EBROKEN,                            /* ե뤬Ƥ */
  DP_EKEEP,                              /* ¸쥳ɤξ񤭤ǰ */
  DP_ENOITEM,                            /* 쥳ɤʤ */
  DP_EALLOC,                             /* ݡmalloc/calloc/reallocˤ˼ */
  DP_EMAP,                               /* ޥåԥ󥰡mmap/munmap/msyncˤ˼ */
  DP_EOPEN,                              /* եΥץopenˤ˼ */
  DP_ECLOSE,                             /* եΥcloseˤ˼ */
  DP_ETRUNC,                             /* եڤͤftruncateˤ˼ */
  DP_ESYNC,                              /* եΥǥƱfsyncˤ˼ */
  DP_ESTAT,                              /* եξּfstatˤ˼ */
  DP_ESEEK,                              /* եΥlseekˤ˼ */
  DP_EREAD,                              /* ե뤫ϡreadˤ˼ */
  DP_EWRITE,                             /* եؤνϡwriteˤ˼ */
  DP_ELOCK,                              /* եΥåfcntlˤ˼ */
  DP_ERENAME,                            /* եΥ͡renameˤ˼ */
  DP_EUNLINK,                            /* եκunlinkˤ˼ */
  DP_EMKDIR,                             /* ǥ쥯ȥκmkdirˤ˼ */
  DP_ERMDIR,                             /* ǥ쥯ȥκrmdirˤ˼ */
  DP_EMISC                               /* ¾Υ顼 */
} DPECODE;

typedef enum {                           /* ץ⡼ɤ */
  DP_OREADER = 1 << 0,                   /* ɤ߹ */
  DP_OWRITER = 1 << 1,                   /* ɤ߽ξ */
  DP_OCREAT = 1 << 2,                    /* ʤк */
  DP_OTRUNC = 1 << 3                     /* äƤ⿷ */
} DPOMODE;

typedef enum {                           /* ʣ񤭹 */
  DP_DOVER,                              /* 񤭤 */
  DP_DKEEP,                              /* ¸ͤݻ */
  DP_DCAT                                /* ¸ͤ˲ä */
} DPDMODE;

typedef struct {                         /* ǡ١ϥɥι¤η */
  char *name;                            /* ե̾ */
  int wmode;                             /* 񤭹߲ǽݤ */
  int fd;                                /* եǥץ */
  int fsiz;                              /* ǡ١եΥ */
  char *map;                             /* ޥå */
  int msiz;                              /* ޥåפΥ */
  int *bucket;                           /* Хå */
  int bnum;                              /* Хåǿ */
  int rnum;                              /* ǼƤ쥳ɿ */
  int fatal;                             /* ̿Ū顼̵ͭ */
  int ioff;                              /* ƥ졼Υեå */
  int asiz;                              /* 饤Ȥδܥ */
  int aunit;                             /* 饤ȤΥ˥åȥ */
} DEPOT;


/* ǥХå */
extern int dpdbgfd;


/* Сʸ */
extern const char *dpversion;


/* ľΥ顼 */
extern DPECODE dpecode;


/* 顼ɤбåʸ֤
   ecode ϥ顼ɤꤹ롣
   ͤϥ顼åʸǤ롣
   ͤΰϽ񤭹߶ػΰǤ롣 */
const char *dperrmsg(DPECODE ecode);


/* ǡ١ե򳫤Υϥɥ֤
   name ϥǡ١ե̾ꤹ롣
   omode ³⡼ɤꤷDP_OREADER ʤ꡼DP_OWRITER ʤ饤Ȥʤ롣
   omode  DP_OWRITER ξ硢DP_OCREAT ޤ DP_OTRUNC ȤΥӥå¤ˤ뤳ȤǤ롣
   DP_OCREAT ϥե뤬̵˿뤳ȤؼDP_OTRUNC ϥե뤬¸ߤƤ
   ľȤؼ롣
   bnum ϥХåǿܰ¤ꤹ뤬0 ʲʤǥեͤȤ롣
   ͤʤǡ١ϥɥǤꡢ顼ʤ NULL Ǥ롣 */
DEPOT *dpopen(const char *name, DPOMODE omode, int bnum);


/* ǡ١եĤ롣
   depot ϥǡ١ϥɥꤹ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣
   ĤϥɥΰϲΤǡʸѤ뤳ȤǤʤʤ롣 */
int dpclose(DEPOT *depot);


/* ǡ١˥쥳ɤɲä롣
   depot ϥ饤³ǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   vbuf ͤΥǡΰΥݥ󥿤ꤹ롣
   vsiz ͤΥǡΰΥХȿǻꤹ뤫ʤ vbuf ʸĹȤʤ롣
   dmode  DP_DOVER  DP_DKEEP  DP_DCAT ǡ¸쥳ɤȽʣݤꤹ롣
   DP_DOVER ϴ¸Υ쥳ɤͤ񤭤DP_DKEEP ϴ¸Υ쥳ɤĤƥ顼֤
   DP_DCAT ϻꤵ줿ͤ¸ͤ˲ä롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣 */   
int dpput(DEPOT *depot, const char *kbuf, int ksiz, const char *vbuf, int vsiz, DPDMODE dmode);


/* ǡ١쥳ɤ롣
   depot ϥ饤³ǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣
   Υ쥳ɤʤ⵶֤ */
int dpout(DEPOT *depot, const char *kbuf, int ksiz);


/* ǡ١쥳ɤͤФ롣
   depot ϥǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   start ͤΰ褫ФǽΥХȤΥեåȤꤹ롣
   max ͤΰ褫Ф륵Хȿǻꤹ뤫ʤ̵¤Ȥʤ롣
   sp  NULL ǤʤСλФΰΥХȿǼ롣
   ͤʤͤǼȤΰؤΥݥ󥿡顼ʤ NULL Ǥ롣
   Υ쥳ɤʤ NULL ֤
   ФȤͤΥ start 꾮äˤϳȤߤʤʤ
   ͤΰϡºݤˤϣХ¿ݤƽüʸ֤ΤǡʸȤѤǤ롣 */
char *dpget(DEPOT *depot, const char *kbuf, int ksiz, int start, int max, int *sp);


/* ǡ١ˤ쥳ɤͤΥ롣
   depot ϥǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   ͤϳ쥳ɤͤΥХȿǤꡢʤäꡢ顼ξ -1 Ǥ롣 */
int dpvsiz(DEPOT *depot, const char *kbuf, int ksiz);


/* ǡ١ΥΥƥ졼롣
   depot ϥǡ١ϥɥꤹ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣 */
int dpiterinit(DEPOT *depot);


/* ǡ١ΥΥƥ졼鼡ΥФ
   depot ϥǡ١ϥɥꤹ롣
   sp  NULL ǤʤСλФΰΥХȿǼ롣
   ͤʤ饭ǼȤΰؤΥݥ󥿡顼ʤ NULL Ǥ롣
   ƥ졼ǸޤǤƳΥ쥳ɤʤ NULL ֤
   ͤΰϡºݤˤϣХ¿ݤƽüʸ֤ΤǡʸȤѤǤ롣 */
char *dpiternext(DEPOT *depot, int *sp);


/* ǡ١Υ饤Ȥꤹ롣
   depot ϥ饤³ǡ١ϥɥꤹ롣
   asiz ϥ饤Ȥδܥꤹ롣
   aunit ϥ饤ȤΥ˥åȥꤹ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣
   쥳ɤͤǼΰΥϡ饤Ȥܿǳݤ롣
   饤ȤͤΥ˥åȥã뤴Ȥ˴ܥܲäƻФ롣
   饤Ȥϥǡ١¸ʤΤǡǡ١򳫤٤˻ꤹ뤳ȡ */
int dpsetalign(DEPOT *depot, int asiz, int aunit);


/* ǡ١Ƥե뤪ӥǥХƱ롣
   depot ϥ饤³ǡ١ϥɥꤹ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣 */
int dpsync(DEPOT *depot);


/* ǡ١Ŭ롣
   depot ϥ饤³ǡ١ϥɥꤹ롣
   bnum ϥХåοǿꤹ뤬0 ʲʤ쥳ɿ˺Ŭͤꤵ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣
   ŬβǤϰեƸΥե֤롣äơΥեʣ
   Υ󥯤䡢ܥå󥯤ȤäƤˤդɬפǤ롣 */
int dpoptimize(DEPOT *depot, int bnum);


/* ǡ١֤̾
   depot ϥǡ١ϥɥꤹ롣
   ͤʤͤǼȤΰؤΥݥ󥿡顼ʤ NULL Ǥ롣 */
char *dpname(DEPOT *depot);


/* ǡ١Υե륵֤
   depot ϥǡ١ϥɥꤹ롣
   ͤʤեΥ顼ʤ -1 Ǥ롣 */
int dpfsiz(DEPOT *depot);


/* ǡ١ΥХåǿ֤
   depot ϥǡ١ϥɥꤹ롣
   ͤʤХåǿ顼ʤ -1 Ǥ롣 */
int dpbnum(DEPOT *depot);


/* ǡ١ΥХåǿ֤
   depot ϥǡ١ϥɥꤹ롣
   ͤʤХåǿ顼ʤ -1 Ǥ롣 */
int dpbusenum(DEPOT *depot);


/* ǡ١Υ쥳ɿ֤
   depot ϥǡ١ϥɥꤹ롣
   ͤʤ쥳ɿ顼ʤ -1 Ǥ롣 */
int dprnum(DEPOT *depot);


/* ǡ١Ѥϥåؿ
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   ͤϥ31ӥåĹΥϥåͤ򻻽ФͤǤ롣 */
int dpinnerhash(const char *kbuf, int ksiz);


/* ǡ١ѤϥåؿΩϥåؿ
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   ͤϥ31ӥåĹΥϥåͤ򻻽ФͤǤ롣 */
int dpouterhash(const char *kbuf, int ksiz);


/* ʾǿ֤
   num Ŭοꤹ롣
   ͤϡꤷƱ礭Ĥʤ٤ǿǤ롣 */
int dpprimenum(int num);



#endif /* Ƚ꽪λ */


/* END OF FILE */
